//  Demo 25: FlagApplet.java
//
//     Another Simple Java Applet to Use the Squares Class
//
//            by Charles W. Neville
//      Copyright Charles W. Neville, June, 1999
//
// I created this Applet by accident while experimenting with the 
// MarchingSquaresApplet.java Applet.  It illustrates two things:
//
//   (1) An unexpected use of the Squares class
//   (2) The power of serendipity, and of experimentation.  Don't be afraid to
//       experiment.  Don't be afraid to write simple prototypes.  And if you 
//       accidently create something really neat, don't be afraid to use it!
//
// A Flag unfurled by a marching band.  Happy Fourth of July!

import java.awt.*;
import java.applet.Applet;
import Square;  // we are going to do things with individual
                // square objects, so, by contrast with
                // MySquaresApplet.java, we have to import the
                // Square class
import Squares;

public class FlagApplet extends Applet {

   Squares r, b;

   public void init() {

     // column of 10 20 by 20 squares spaced 30
     // pixels apart
     r = new Squares(50, 50, 20, Color.red, 75, 4);
     b = new Squares(330, 90, 20, Color.blue, 75, 3);
   }

   public void paint(Graphics g) {

      for(int i = 1; i <= 35; i++) {

        unfurl(g,8);
      }

   } // paint


   // unfurl a flag
   public void unfurl(Graphics g, int n) {

     Color backgroundColor = getBackground();

     for(int i = 1; i <= n; i++) {

        // stripes
        r.move(1, 0);
        b.move(-1, 0);
        r.draw(g);
        b.draw(g);

        try {
          Thread.sleep(50);  // 50 ms pause
        }
        catch (InterruptedException e) {
          // do nothing
        }

     } // for
   } // unfurl

} // class FlagApplet
        